For AI agents: a documentation index is available at the root level at /llms.txt and /llms-full.txt. Append /llms.txt to any URL for a page-level index, or .md for the markdown version of any page.
      • AstroFully-managed data operations, powered by Apache Airflow.
      • Astro Private CloudRun Airflow-as-a-service in your environment.
      • Professional ServicesExpert Airflow services for your enterprise's success.
    • Tools
      • Cosmos
      • Orbiter
      • CLI
      • AI SDK
      • Agents
      • Blueprint
      • UpdatesThe State of Airflow 2026See the insights from over 5,800 data practitioners in the full report. Download Now ➔
  • Customers
  • Docs
    • Insights
      • Blog
      • Webinars
      • Resource Library
      • Events
    • Education
      • Academy
      • What is Airflow?
  • Pricing
Get Started Free
  • Astro API v1
    • Overview
    • Get started
    • Versioning and support
    • Migrate to v1
    • Deploy with the API
  • API Reference
      • POSTCreate a new environment object
      • DELDelete an environment object
      • POSTExclude linking an environment object
      • GETGet environment object
      • GETList environment objects
      • POSTUpdate an environment object
    • Changelog
    • Book Office Hours

Product

  • Platform Overview
  • Astro
  • Astro Observe
  • Astro Private Cloud
  • Security & Trust
  • Pricing

Tools & Services

  • Cosmos
  • Docs
  • Professional Services
  • Product Updates

Use Cases

  • AI Ops
  • Data Observability
  • ETL/ELT
  • ML Ops
  • Operational Analytics
  • All Use Cases

Industries

  • Financial Services
  • Gaming
  • Retail
  • Manufacturing
  • Healthcare
  • All Industries

Resources

  • Academy
  • eBooks & Guides
  • Blog
  • Webinars
  • Events
  • The Data Flowcast Podcast
  • All Resources

Airflow

  • What is Airflow
  • Airflow on Astro
  • Airflow 3.0
  • Airflow Upgrades
  • Airflow Use Cases
  • Airflow 2.x End of Life

Company

  • Our Story
  • Customers
  • Newsroom
  • Careers
  • Contact

Support

  • Knowledge Base
  • Status
  • Contact Support
GitHubYouTubeLinkedInx
  • Legal
  • Privacy
  • Terms of Service
  • Consent Preferences

  • Do Not Sell or Share My Personal information
  • Limit the Use Of My Sensitive Personal Information

Apache Airflow®, Airflow, and the Airflow logo are trademarks of the Apache Software Foundation. Copyright © Astronomer 2026. All rights reserved.

LogoLogo
API ReferenceEnvironment

List environment objects

GET
https://api.astronomer.io/v1/organizations/:organizationId/environment-objects
GET
/v1/organizations/:organizationId/environment-objects
$curl https://api.astronomer.io/v1/organizations/organizationId/environment-objects \
> -H "Authorization: Bearer <token>" \
> -H "Content-Type: application/json"
1{
2 "environmentObjects": [
3 {
4 "objectKey": "prod_db_connection",
5 "objectType": "CONNECTION",
6 "scope": "WORKSPACE",
7 "scopeEntityId": "ws-1234abcd5678efgh",
8 "airflowVariable": {
9 "isSecret": true,
10 "value": ""
11 },
12 "autoLinkDeployments": true,
13 "connection": {
14 "type": "Postgres",
15 "connectionAuthType": {
16 "airflowType": "basic",
17 "authMethodName": "BasicAuth",
18 "description": "Basic authentication using username and password",
19 "id": "auth-basic-001",
20 "name": "Basic Authentication",
21 "parameters": [
22 {
23 "airflowParamName": "username",
24 "dataType": "string",
25 "description": "The username for authentication",
26 "friendlyName": "Username",
27 "isInExtra": false,
28 "isRequired": true,
29 "isSecret": false,
30 "example": "admin",
31 "pattern": "^[a-zA-Z0-9_]+$"
32 },
33 {
34 "airflowParamName": "password",
35 "dataType": "string",
36 "description": "The password for authentication",
37 "friendlyName": "Password",
38 "isInExtra": false,
39 "isRequired": true,
40 "isSecret": true,
41 "example": "P@ssw0rd!",
42 "pattern": "^.{8,}$"
43 }
44 ],
45 "providerPackageName": "apache-airflow-providers-http",
46 "guidePath": "https://docs.astronomer.io/auth/basic-auth",
47 "providerLogo": "https://assets.astronomer.io/logos/basic-auth.png"
48 },
49 "extra": {
50 "timeout": 30,
51 "retries": 3
52 },
53 "host": "db.example.com",
54 "login": "admin",
55 "password": "P@ssw0rd!",
56 "port": 5432,
57 "schema": "public"
58 },
59 "createdAt": "2024-05-10T12:00:00Z",
60 "createdBy": {
61 "id": "clm8qv74h000008mlf08scq7k",
62 "apiTokenName": "deploy-token-01",
63 "avatarUrl": "https://avatars.astronomer.io/users/janedoe.png",
64 "fullName": "Jane Doe",
65 "subjectType": "USER",
66 "username": "jane.doe@astronomer.io"
67 },
68 "excludeLinks": [
69 {
70 "scope": "DEPLOYMENT",
71 "scopeEntityId": "dep-1234567890abcdef"
72 }
73 ],
74 "id": "envobj-9876543210abcdef",
75 "links": [
76 {
77 "scope": "DEPLOYMENT",
78 "scopeEntityId": "dep-abcdef1234567890",
79 "airflowVariableOverrides": {
80 "value": "override_value"
81 },
82 "connectionOverrides": {
83 "extra": {
84 "sslmode": "require"
85 },
86 "host": "db-override.example.com",
87 "login": "override_user",
88 "password": "OverrideP@ss1",
89 "port": 5433,
90 "schema": "override_schema",
91 "type": "Postgres"
92 },
93 "metricsExportOverrides": {
94 "authType": "BASIC",
95 "basicToken": "override-basic-token-123",
96 "endpoint": "https://metrics.override.example.com",
97 "exporterType": "PROMETHEUS",
98 "headers": {
99 "Authorization": "Bearer override-token"
100 },
101 "labels": {
102 "env": "staging",
103 "team": "data-engineering"
104 },
105 "password": "overridePass123",
106 "username": "overrideUser"
107 }
108 }
109 ],
110 "metricsExport": {
111 "endpoint": "https://metrics.astronomer.io/prometheus",
112 "exporterType": "PROMETHEUS",
113 "authType": "BASIC",
114 "basicToken": "basic-token-abc123",
115 "headers": {
116 "Authorization": "Bearer token123"
117 },
118 "labels": {
119 "env": "production",
120 "team": "analytics"
121 },
122 "password": "prodPass!23",
123 "username": "metricsUser"
124 },
125 "sourceScope": "WORKSPACE",
126 "sourceScopeEntityId": "ws-1234abcd5678efgh",
127 "updatedAt": "2024-05-15T15:30:00Z",
128 "updatedBy": {
129 "id": "clm8qv74h000008mlf08scq7k",
130 "apiTokenName": "deploy-token-01",
131 "avatarUrl": "https://avatars.astronomer.io/users/janedoe.png",
132 "fullName": "Jane Doe",
133 "subjectType": "USER",
134 "username": "jane.doe@astronomer.io"
135 }
136 }
137 ],
138 "limit": 1,
139 "offset": 1,
140 "totalCount": 1
141}
List environment objects in a Workspace or Deployment.
Was this page helpful?
Previous

Update an environment object

Next
Built with

Authentication

AuthorizationBearer

Bearer authentication of the form Bearer <token>, where token is your auth token.

Path parameters

organizationIdstringRequired
The ID of the Organization to which the environment object belongs.

Query parameters

offsetintegerOptional>=0Defaults to 0
The number of results to skip before returning values.
limitintegerOptional>=0Defaults to 20
The maximum number of results to return.
sortslist of enumsOptional

A list of field names to sort by, and whether to show results as ascending or descending. Formatted as <fieldName>:asc or <fieldName>:desc.

workspaceIdstringOptional
The Workspace ID to filter for. The API returns details for all environment objects belonging only to this specified Workspace.
deploymentIdstringOptional
The Deployment ID to filter for. The API returns details for all environment objects belonging only to this specified Deployment.
objectTypeenumOptional
The environment object type to filter for. The API returns details for all environment objects belonging only to this specified object type.
Allowed values:
objectKeystringOptional
The environment object key to filter for. The API returns details for all environment objects belonging only to the specified object key.
showSecretsbooleanOptional
If true, returns the actual values of fields of type secret in the API response.
resolveLinkedbooleanOptional
Resolve and return the environment objects linked to the specified Deployment or Workspace in the API response.

Response

OK
environmentObjectslist of objects
The list of environment objects
limitinteger
The maximum number of environment objects in current page
offsetinteger
The offset of the current page of environment objects
totalCountinteger
The total number of environment objects

Errors

401
Unauthorized Error
403
Forbidden Error
404
Not Found Error
405
Method Not Allowed Error
500
Internal Server Error